<?php

/**
 * @file
 * Contains \Drupal\ebt_tabs\Plugin\Field\FieldWidget\EbtSettingsTabsWidget.
 */

namespace Drupal\ebt_tabs\Plugin\Field\FieldWidget;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\WidgetBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Plugin implementation of the 'ebt_settings_tabs' widget.
 *
 * @FieldWidget(
 *   id = "ebt_settings_tabs",
 *   label = @Translation("EBT Tabs settings"),
 *   field_types = {
 *     "ebt_settings"
 *   }
 * )
 */
class EbtSettingsTabsWidget extends WidgetBase {

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    $element['option1'] = array(
      '#title' => $this->t('Option1'),
      '#type' => 'textfield',
      '#default_value' => !empty($items[$delta]->ebt_settings['option1']) ? $items[$delta]->ebt_settings['option1'] : NULL,
    );
    $element['option2'] = array(
      '#title' => $this->t('Option2'),
      '#type' => 'radios',
      '#options' => [
        'jquery_ui' => 'jQuery UI',
        'flexslider' => 'FlexSlider',
      ],
      '#default_value' => isset($items[$delta]->ebt_settings['option2']) ? $items[$delta]->ebt_settings['option2'] : NULL,
    );
    return $element;
  }

  /**
   * {@inheritdoc}
   */
  public function massageFormValues(array $values, array $form, FormStateInterface $form_state) {
    foreach ($values as &$value) {
      $value += ['ebt_settings' => []];
    }
    return $values;
  }

}
